require "defines"
require "util"
remote.add_interface("UpgUnl",
{fix = function()--this function should fix technologies broken by cheating.
    for f in pairs(global.counts) do
            for t in pairs(global.counts[f]) do
                game.forces[f].technologies[t].enabled=true;
                game.forces[f].technologies[t].researched=false;
            end
    end 
end,
})
--this function is used to set the environment when game is started or loaded
function init(force)
--prepare a table of actions for manipulating modifiers
--links to factorio objects are not persistent, thus we'll have to rebuild the table on each load
    global.counts=global.counts or {}
    global.counts[force]=global.counts[force] or {}
    global.just_finished=false
    global.just_finished_tech={};
    local force=force;
    --search for technologies added by this mod
    for name,teh in pairs(game.forces[force].technologies) do
        repeat --lua doesn't have continue, hence we use this trick
            if name:find('^unl%-(.+)%-(.+)$') and (global.counts[force][name]==nil or not(pcall(global.counts[force][name]['get']))) then--the mighty power of regex
                --process those found
                --first process some special cases that I can't fit into pattern now
                if name=='unl-manual-mining-speed-modifier' then
                    get=function(); return function() return game.forces[force].manual_mining_speed_modifier; end; end;
                    set=function(); return function(value); game.forces[force].manual_mining_speed_modifier=value; end; end;
                elseif name=='unl-laboratory-speed-modifier' then
                    get=function() return function(); return game.forces[force].laboratory_speed_modifier; end; end
                    set=function() return function(value); game.forces[force].laboratory_speed_modifier=value; end; end
                elseif name=='unl-gun-turret-damage' then
                    get=function() return function(); return game.forces[force].get_turret_attack_modifier('gun-turret'); end; end
                    set=function() return function(value); game.forces[force].set_turret_attack_modifier('gun-turret',value); end; end
                elseif name=='unl-laser-turret-damage' then
                    get=function() return function(); return game.forces[force].get_turret_attack_modifier('laser-turret'); end; end
                    set=function() return function(value); game.forces[force].set_turret_attack_modifier('laser-turret',value); end; end
                --then process the ammotypes, which all have the same cource of actions
                elseif name:find('^unl%-(.+)%-damage$') then
                    local _,_,ammotype = name:find('^unl%-(.+)%-damage$');
                    get=function() return function(); return game.forces[force].get_ammo_damage_modifier(ammotype); end; end
                    set=function() return function(value); game.forces[force].set_ammo_damage_modifier(ammotype,value); end; end
                elseif name:find('^unl%-(.+)%-speed$') then
                    local _,_,ammotype = name:find('^unl%-(.+)%-speed$');
                    get=function() return function(); return game.forces[force].get_gun_speed_modifier(ammotype); end; end
                    set=function() return function(value); game.forces[force].set_gun_speed_modifier(ammotype,value); end; end
                else break -- this is probably not tech from my mod                
                end--inner if
                --make the entry for found tech
                if global.counts[force][name] and global.counts[force][name]['count'] then
                    count=global.counts[force][name]['count']
                else count=0
                end
                global.counts[force][name]={get=get(),set=set(),count=count};
            end--outer if
        until true
    end
end

game.on_event(defines.events.on_player_created, function(event) 
    init(game.players[event.player_index].force.name); 
end)
game.on_load(function()
    for _,f in pairs(game.forces) do 
        if f.players~=nil then
            init(f.name); 
        end; 
    end;
end)
--this handles the finished research
game.on_event(defines.events.on_research_finished,function(event) 
    t=event.research;
--see if it's mod technology, for which table entry is guaranteed to exist by that moment
    if global.counts[t.force.name][t.name] then
        v=global.counts[t.force.name][t.name].get()
        c=global.counts[t.force.name][t.name].count
        --function which determines the bonus
        local i=1;
        repeat dif=1/(3*(i+1)); i=i+1; until c<3/2*(i^2+3*i);
        global.counts[t.force.name][t.name].set(v+dif)
        global.counts[t.force.name][t.name].count=c+1;
        global.just_finished=true--schedule the unmarking of finished upgrade
        global.just_finished_tech=game.forces[t.force.name].technologies[t.name];
        --inform players about their bonus
        for _,player in pairs(game.forces[t.force.name].players) do
            player.print({"technology-name."..t.name})
            player.print("Multiplier increased by "..dif)
            player.print("Multiplier is now "..global.counts[t.force.name][t.name].get())
        end
    end
    end)
--this performs final steps of handling research
game.on_event(defines.events.on_tick,function(event)
    if global.just_finished then
        global.just_finished_tech.researched=false;
        global.just_finished_tech.enabled=true;
        global.just_finished=false;
    end
end)
--this handles the merging of two forces, whatever that will be
game.on_event(defines.events.on_forces_merging,function(event)
    f1=event.source; f2=event.destination;
    for n in pairs(f2.technologies) do
    --it just takes the best counters from both forces
        global.counts[f2.name][n].count=
            (global.counts[f2.name][n].count >= global.counts[f1.name][n].count) and global.counts[f2.name][n].count or global.counts[f1.name][n].count
    end
end)
